using SoftwareInstallationContracts.BindingModels;
using SoftwareInstallationContracts.BusinessLogicsContracts;
using SoftwareInstallationContracts.SearchModels;
using SoftwareInstallationContracts.StoragesContracts;
using SoftwareInstallationContracts.ViewModels;
using Microsoft.Extensions.Logging;

namespace SoftwareInstallationBusinessLogic.BusinessLogics
{
    public class PackageLogic : IPackageLogic
    {
        private readonly ILogger _logger;
        private readonly IPackageStorage _componentStorage;
        public PackageLogic(ILogger<PackageLogic> logger, IPackageStorage componentStorage)
        {
            _logger = logger;
            _componentStorage = componentStorage;
        }

        public bool Create(PackageBindingModel model)
        {
            CheckModel(model);
            if (_componentStorage.Insert(model) == null)
            {
                _logger.LogWarning("Insert operation failed");
                return false;
            }
            return true;
        }

        public bool Delete(PackageBindingModel model)
        {
            CheckModel(model, false);
            _logger.LogInformation("Delete. Id:{Id}", model.Id);
            if (_componentStorage.Delete(model) == null)
            {
                _logger.LogWarning("Delete operation failed");
                return false;
            }
            return true;
        }

        public PackageViewModel? ReadElement(PackageSearchModel model)
        {
            if (model == null)
            {
                throw new ArgumentNullException(nameof(model));
            }
            _logger.LogInformation("ReadElement. PackageName:{PackageName}.Id:{ Id}", model.PackageName, model.Id);
            var element = _componentStorage.GetElement(model);
            if (element == null)
            {
                _logger.LogWarning("ReadElement element not found");
                return null;
            }
            _logger.LogInformation("ReadElement find. Id:{Id}", element.Id);
            return element;
        }

        public List<PackageViewModel>? ReadList(PackageSearchModel? model)
        {
            _logger.LogInformation("ReadList. PackageName:{PackageName}.Id:{ Id} ", model?.PackageName, model?.Id);
            var list = (model == null) ? _componentStorage.GetFullList() : _componentStorage.GetFilteredList(model);
            if (list == null)
            {
                _logger.LogWarning("ReadList return null list");
                return null;
            }
            _logger.LogInformation("ReadList. Count:{Count}", list.Count);
            return list;
        }

        public bool Update(PackageBindingModel model)
        {
            CheckModel(model);
            if (_componentStorage.Update(model) == null)
            {
                _logger.LogWarning("Update operation failed");
                return false;
            }
            return true;
        }
        private void CheckModel(PackageBindingModel model, bool withParams = true)
        {
            if (model == null)
            {
                throw new ArgumentNullException(nameof(model));
            }
            if (!withParams)
            {
                return;
            }
            if (string.IsNullOrEmpty(model.PackageName))
            {
                throw new ArgumentNullException("Нет названия кондитерского изделия",
                nameof(model.PackageName));
            }
            if (model.Price <= 0)
            {
                throw new ArgumentNullException("Цена кондитерского изделия должна быть больше 0", nameof(model.Price));
            }
            _logger.LogInformation("Package. PackageName:{PackageName}.Cost:{ Cost}. Id: { Id}",
                model.PackageName, model.Price, model.Id);
            var element = _componentStorage.GetElement(new PackageSearchModel
            {
                PackageName = model.PackageName
            });
            if (element != null && element.Id != model.Id)
            {
                throw new InvalidOperationException("Кондитерское изделие с таким названием уже есть");
            }
        }
    }
}